;=====================================================================
; Expected VBE MODE                                                  ;
; MODE : vbe mode number                                             ;
; X : x resolution                                                   ;
; Y : y resolution                                                   ;
; BITS_RGB : bits per pixel  ; support 16/24/32                      ;
; If the expected result cannot be found, the largest                ;
; smaller than expected value will be looked for                     ;
;--------------------------------------------------------------------;
%ifndef DEF_VBE_MODE                                                 ;
  %define DEF_VBE_MODE 0x0000 ;                                      ;
; %define DEF_VBE_MODE 0x0198 ; qemu 2560*1440:32                    ;
; %define DEF_VBE_MODE 0x0190 ; qemu 1920*1080:16                    ;
; %define DEF_VBE_MODE 0x0191 ; qemu 1920*1080:24                    ;
; %define DEF_VBE_MODE 0x0192 ; qemu 1920*1080:32                    ;
; %define DEF_VBE_MODE 0x018d ; qemu 1280*720:16                     ;
; %define DEF_VBE_MODE 0x018e ; qemu 1280*720:24                     ;
; %define DEF_VBE_MODE 0x018f ; qemu 1280*720:32                     ;
; %define DEF_VBE_MODE 0x0114 ; qemu 800*600:16                      ;
; %define DEF_VBE_MODE 0x0115 ; qemu 800*600:24                      ;
%endif                                                               ;
%ifndef DEF_VBE_MODE_X                                               ;
  %define DEF_VBE_MODE_X 1920                                        ;
%endif                                                               ;
%ifndef DEF_VBE_MODE_Y                                               ;
  %define DEF_VBE_MODE_Y 1080                                        ;
%endif                                                               ;
%ifndef DEF_VBE_MODE_BITS_RGB                                        ;
  %define DEF_VBE_MODE_BITS_RGB 32                                   ;
%endif                                                               ;
;=====================================================================

;=====================================================================
;= Variable (512 bytes)                                              =
;=====================================================================
%define DEF_AREA_VAR_START    0x7E00                                 ;
%define DEF_AREA_VAR_END      0x8000                                 ;
%define DEF_AREA_VAR_SEGMENT  0x07E0                                 ;
%define DEF_AREA_VAR_OFFSET   0x0000                                 ;
;--------------------------------------------------------------------;
%define DEF_VAR_BOOT_DRIVE_NUMBER         0x7E00 ; -0x7E00  1 b      ;
%define DEF_VAR_VBE_MODE                  0x7E01 ; -0x7E02  2 b      ;
%define DEF_VAR_VBE_MODE_SIZE             0x7E03 ; -0x7E04  2 b      ;
%define DEF_VAR_E820_ENTRY_SIZE           0x7E05 ; -0x7E06  2 b      ;
; reserved                                0x7E07 ; -0x7E07           ;
%define DEF_VAR_DEBUG_VALUE               0x7E08 ; -0x7E0F  8 b      ;
%define DEF_VAR_DISPLAY_LINE              0x7E10 ; -0x7E10  1 b      ;
%define DEF_VAR_DISPLAY_POS               0x7E11 ; -0x7E14  4 b      ;
%define DEF_VAR_KERNEL_SIZE               0x7E15 ; -0x7E18  4 b      ;
; reserved                                0x7E19 ; -0x7E1F           ;
%define DEF_VAR_FILTER_VBE_PERFECT_MODE   0x7E20 ; -0x7E21  2 b      ;
%define DEF_VAR_FILTER_VBE_X              0x7E22 ; -0x7E23  2 b      ;
%define DEF_VAR_FILTER_VBE_Y              0x7E24 ; -0x7E25  2 b      ;
%define DEF_VAR_FILTER_VBE_BITS_RGB       0x7E26 ; -0x7E26  1 b      ;
%define DEF_VAR_FILTER_VBE_VALID_MODE     0x7E27 ; -0x7E28  2 b      ;
; reserved                                0x7E29 ; -0x7EEF           ;
%define DEF_VAR_DAP_LENGTH  0x10                                     ;
%define DEF_VAR_DAP                       0x7EF0 ;                   ;
%define DEF_VAR_DAP_SIZE                  0x7EF0 ; -0x7EF0  1 b      ;
%define DEF_VAR_DAP_UNUSED                0x7EF1 ; -0x7EF1  1 b      ;
%define DEF_VAR_DAP_TOTAL                 0x7EF2 ; -0x7EF3  2 b      ;
%define DEF_VAR_DAP_OFFSET                0x7EF4 ; -0x7EF5  2 b      ;
%define DEF_VAR_DAP_SEGMENT               0x7EF6 ; -0x7EF7  2 b      ;
%define DEF_VAR_DAP_LBA_LOW               0x7EF8 ; -0x7EFB  4 b      ;
%define DEF_VAR_DAP_LBA_HIGH              0x7EFC ; -0x7EFF  4 b      ;
; reserved                                0x7F00 ; -0x7FFF           ;
;--------------------------------------------------------------------;

;=====================================================================
;= FAT32 Root Entry (4,096 bytes)                                    =
;=====================================================================
%define DEF_AREA_FAT32_ROOT_ENTRY_START    0x8000                    ;
%define DEF_AREA_FAT32_ROOT_ENTRY_END      0x9000                    ;
%define DEF_AREA_FAT32_ROOT_ENTRY_SEGMENT  0x0800                    ;
%define DEF_AREA_FAT32_ROOT_ENTRY_OFFSET   0x0000                    ;
;=====================================================================

;=====================================================================
;= FAT32 FAT Entry (4,096 bytes)                                     =
;=====================================================================
%define DEF_AREA_FAT32_FAT_ENTRY_START    0x9000                     ;
%define DEF_AREA_FAT32_FAT_ENTRY_END      0xA000                     ;
%define DEF_AREA_FAT32_FAT_ENTRY_SEGMENT  0x0900                     ;
%define DEF_AREA_FAT32_FAT_ENTRY_OFFSET   0x0000                     ;
;=====================================================================

;=====================================================================
;= E820 ENTRY (4,096 bytes)                                          =
;=====================================================================
%define DEF_AREA_E820_ENTRY_START    0xA000                          ;
%define DEF_AREA_E820_ENTRY_END      0xB000                          ;
%define DEF_AREA_E820_ENTRY_SEGMENT  0x0A00                          ;
%define DEF_AREA_E820_ENTRY_OFFSET   0x0000                          ;
;=====================================================================

;=====================================================================
;= VBE Info (512 bytes)                                              =
;=====================================================================
%define DEF_AREA_VBE_INFO_START                  0xB000              ;
%define DEF_AREA_VBE_INFO_END                    0xB200              ;
%define DEF_AREA_VBE_INFO_SEGMENT                0x0B00              ;
%define DEF_AREA_VBE_INFO_OFFSET                 0x0000              ;
;=====================================================================

;=====================================================================
;= Selected VBE Mode Info (3,584 bytes)                              =
;=====================================================================
%define DEF_AREA_SELECTED_VBE_MODE_INFO_START    0xB200              ;
%define DEF_AREA_SELECTED_VBE_MODE_INFO_END      0xC000              ;
%define DEF_AREA_SELECTED_VBE_MODE_INFO_SEGMENT  0x0B20              ;
%define DEF_AREA_SELECTED_VBE_MODE_INFO_OFFSET   0x0000              ;
;=====================================================================

;=====================================================================
;= Reserved 0xC000 - 0xFFFF                                          =
;=====================================================================

;=====================================================================
;= Loader (65,536 bytes)                                             =
;=====================================================================
%define DEF_AREA_LOADER_START                  0x010000              ;
%define DEF_AREA_LOADER_END                    0x020000              ;
%define DEF_AREA_LOADER_SEGMENT                0x001000              ;
%define DEF_AREA_LOADER_OFFSET                 0x000000              ;
;=====================================================================

;=====================================================================
;= VBE Mode Info (65,536 bytes)                                      =
;=====================================================================
%define DEF_AREA_VBE_MODE_INFO_START                  0x020000       ;
%define DEF_AREA_VBE_MODE_INFO_END                    0x030000       ;
%define DEF_AREA_VBE_MODE_INFO_SEGMENT                0x002000       ;
%define DEF_AREA_VBE_MODE_INFO_OFFSET                 0x000000       ;
;=====================================================================

;=====================================================================
;= Page Table (65,536 bytes)                                         =
;=====================================================================
%define DEF_AREA_PAGE_TABLE_START                  0x030000          ;
%define DEF_AREA_PAGE_TABLE_END                    0x040000          ;
%define DEF_AREA_PAGE_TABLE_SEGMENT                0x003000          ;
%define DEF_AREA_PAGE_TABLE_OFFSET                 0x000000          ;
;=====================================================================

;=====================================================================
;= KERNEL BUF (65,536 bytes)                                         =
;=====================================================================
%define DEF_AREA_KERNEL_BUF_START                  0x040000          ;
%define DEF_AREA_KERNEL_BUF_END                    0x050000          ;
%define DEF_AREA_KERNEL_BUF_SEGMENT                0x004000          ;
%define DEF_AREA_KERNEL_BUF_OFFSET                 0x000000          ;
;=====================================================================

;=====================================================================
;= Stack (131,080 bytes)                                             =
;=====================================================================
%define DEF_AREA_STACK_START                  0x050000               ;
%define DEF_AREA_STACK_END                    0x070008               ;
%define DEF_AREA_STACK_SEGMENT                0x005000               ;
%define DEF_AREA_STACK_OFFSET                 0x000000               ;
;=====================================================================

;=====================================================================
;= Reserved 0x060000 - 0x080000                                      =
;=====================================================================

;=====================================================================
;= KERNEL                                                            =
;=====================================================================
%define DEF_AREA_KERNEL_START                  0x100000              ;
%define DEF_AREA_KERNEL_SEGMENT                0x010000              ;
%define DEF_AREA_KERNEL_OFFSET                 0x000000              ;
;=====================================================================

