;----------------------------------------------- [DEF]

%define FAT32_BYTES_PER_SECTOR     0x00000200
%define FAT32_SECTORS_PER_CLUSTER  0x00000020
%define FAT32_BYTES_PER_CLUSTER    0x00004000
%define FAT32_FAT_REGION           0x00000020
%define FAT32_ROOT_REGION          0x00007720

;----------------------------------------------- [OEM Manufacturer; offset: 0x03; length: 8 Bytes]

BPB_OEMName               DB    "AKVICOR "              ; 8 Bytes

;----------------------------------------------- [BIOS Parameter Block; offset: 0x0b; length: 25 Bytes]

; The number of bytes, in little-endian
BPB_BytesPerSec           DW    0x0200                  ; offset: 0x0b[11]; length: 2  Bytes
; Number of Sectors per Cluster
BPB_SecPerClus            DB    0x20                    ; offset: 0x0d[13]; length: 1  Bytes
; Number of Reserved Sectors
BPB_RsvdSecCnt            DW    0x0020                  ; offset: 0x0e[14]; length: 2  Bytes
; Number of File Allocation Tables
BPB_NumFATs               DB    0x02                    ; offset: 0x10[16]; length: 1  Bytes
; Root Entries. The total number file name
; entires than can be store in the root folder
; of the volume.
; For FAT32 volumes, this number is set to zero
BPB_RootEntCnt            DW    0x0000                  ; offset: 0x11[17]; length: 2  Bytes
; 0 For FAT32
BPB_TotSec16              DW    0x0000                  ; offset: 0x13[19]; length: 2  Bytes
; Media Type: F0 removable,
; F8 fixed media, i.e. hard disk
BPB_Media                 DB    0xF8                    ; offset: 0x15[21]; length: 1  Bytes
; For FAT32, this field should be zero
BPB_FATSz16               DW    0x0000                  ; offset: 0x16[22]; length: 2  Bytes
; Sectors per track
BPB_SecPerTrk             DW    0x0020                  ; offset: 0x18[24]; length: 2  Bytes
; Number of heads
BPB_NumHeads              DW    0x0040                  ; offset: 0x1A[26]; length: 2  Bytes
; Count of hidden sectors preceeding the
; partition that contains the FAT volume
BPB_HiddSec               DD    0x00000000              ; offset: 0x1C[28]; length: 4  Bytes
; Total count of sectors
BPB_TotSec32              DD    0x03B851E0              ; offset: 0x20[32]; length: 4  Bytes

;----------------------------------------------- [Extended BIOS Parameter Block; offset: 0x24; length: 54 Bytes]

; 32-bit count of sectors occupied by one FAT
BPB_FATSz32               DD    0x00003B80               ; offset: 0x24[36]; length: 4  Bytes
; Bits [0-3 ]: Zero based number of active FAT
; Bits [4-6 ]: Reserved
; Bits [7   ]:
;  0: The FAT is mirrored at runtime into all FATs
;  1: Only one FAT is active
; Bits [8-15]: Reserved
BPB_ExtFlags              DW    0x0000                   ; offset: 0x28[40]; length: 2  Bytes
; High Byte: Major revision number
; The sample value prevents windows
; from loading this FAT partition
BPB_FSVer                 DW    0x0000                   ; offset: 0x2A[42]; length: 2  Bytes
; Cluster number of the first cluster
; of the root directory
BPB_RootClus              DD    0x00000002               ; offset: 0x2C[44]; length: 4  Bytes
; File system info. Usually 1
BPB_FSInfo                DW    0x0001                   ; offset: 0x30[48]; length: 2  Bytes
; If not zero, indicates the sector number
; in the reserved area of the volume of a
; copy of the boot record
BPB_BkBootSec             DW    0x0006                   ; offset: 0x32[50]; length: 2  Bytes
; Reserved
BPB_Reserved              TIMES 12 DB 0                  ; offset: 0x34[52]; length: 12 Bytes
; Drive Number
BS_DrvNum                 DB    0x80                     ; offset: 0x40[64]; length: 1  Bytes
; Reserved
BS_Reserved1              DB    0x00                     ; offset: 0x41[65]; length: 1  Bytes
; Boot signature
BS_BootSig                DB    0x29                     ; offset: 0x42[66]; length: 1  Bytes
; Volume ID
BS_VolID                  DD    0xA1385437               ; offset: 0x43[67]; length: 4  Bytes
; Volume Label
BS_VolLab                 DB    "AOS    BOOT"            ; offset: 0x47[71]; length: 11 Bytes
; Volume ID
BS_FilSysType             DB    "FAT32   "               ; offset: 0x52[82]; length: 8  Bytes

;----------------------------------------------- [Bootstrap Code; offset: 0x5A[90]; length: 420 Bytes]
